Bug 839735 - openssl: environment settings honored when used in privileged apps
openssl: environment settings honored when used in privileged apps
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20130214,repor...
: Security
Depends On: 911051 911052 911061 911063
Blocks: 839918 919304
  Show dependency treegraph
 
Reported: 2012-07-12 12:53 EDT by Tomas Hoger
Modified: 2014-09-09 05:26 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-30 09:33:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Portability patch for __secure_getenv() (931 bytes, patch)
2013-03-27 03:59 EDT, Tomas Mraz
no flags Details | Diff

  None (edit)
Description Tomas Hoger 2012-07-12 12:53:50 EDT
OpenSSL library reads certain settings from environment variables.  Certain settings, such as OPENSSL_CONF containing path to an openssl.cnf configuration file, are read even when OpenSSL library is used in an application running with elevated privileges (setuid or setgid application, application with file system capabilities).  This may allow local attacker to escalate their privileges.

Some getenv() call already protected by calls to OPENSSL_issetugid() and not read in setuid or setgid applications, but it's implementation does not take into an account file system capabilities.

Following upstream ticket contains a proposed patch with several improvements:
http://rt.openssl.org/Ticket/Display.html?id=2532&user=guest&pass=guest
Comment 11 Huzaifa S. Sidhpurwala 2013-02-14 05:07:59 EST
This is public via:

http://rt.openssl.org/Ticket/Display.html?id=2532
Comment 12 Fedora Update System 2013-03-02 14:55:24 EST
openssl-1.0.1e-3.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 errata-xmlrpc 2013-03-04 16:15:41 EST
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5
  Red Hat Enterprise Linux 6

Via RHSA-2013:0587 https://rhn.redhat.com/errata/RHSA-2013-0587.html
Comment 14 Fedora Update System 2013-03-07 19:02:10 EST
openssl-1.0.0k-1.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 18 Tomas Mraz 2013-03-27 03:59:06 EDT
Created attachment 716927 [details]
Portability patch for __secure_getenv()

This patch which needs to be applied in addition to the ...-secure-getenv.patch adds implementation of __secure_getenv() on non-linux platforms.
Comment 19 Mladen Turk 2013-03-27 05:34:14 EDT
The portability patch for __secure_getenv() works as expected on non-linux platforms.

Note You need to log in before you can comment on or make changes to this bug.